import java.io.IOException;
import java.util.Iterator;

import com.hp.hpl.jena.rdf.model.InfModel;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.reasoner.Reasoner;
import com.hp.hpl.jena.reasoner.ReasonerRegistry;
import com.hp.hpl.jena.reasoner.ValidityReport;
import com.hp.hpl.jena.util.ModelLoader;
import com.hp.hpl.jena.vocabulary.RDF;
/**
* RDQLNG̃Tv
 */
public class Example6 {

	public static void main(String[] args) throws IOException {
		//	XL[}̓ǂݍ				
		Model schema = ModelLoader.loadModel("file:data/schema.rdf");
		//	CX^X̓ǂݍ
		Model data = ModelLoader.loadModel("file:data/data.rdf");
		//	ReasonerIuWFNg̎擾
		Reasoner reasoner = ReasonerRegistry.getRDFSReasoner();
		//	InfModelIuWFNg̐
		InfModel infmodel = ModelFactory.createInfModel(reasoner, schema, data);

		/*
		 * InfModel̃oOŐړƂtqh̃}bvɐlĂȂ
		 * 悤Ȃ̂ŋIɒlĂD
		 */
		infmodel.setNsPrefixes(schema.getNsPrefixMap());
		infmodel.setNsPrefixes(data.getNsPrefixMap());

		System.out.println("---------------_Tv----------------");
		Resource kotaro = infmodel.getResource("http://example#Y");
		System.out.println("Ỹ^Cv:");
		printStatements(infmodel, kotaro, RDF.type, null);

		Resource person = infmodel.getResource("http://example#l");
		System.out.println("lԂ̃^Cv:");
		printStatements(infmodel, person, RDF.type, null);
		System.out.println("---------------_Tv܂--------");
		System.out.println("---------------qcě----------------");
		ValidityReport validity = infmodel.validate();
		if (validity.isValid()) {
			System.out.println("\nOK");
		} else {
			System.out.println("Conflicts");
			for (Iterator i = validity.getReports(); i.hasNext();) {
				ValidityReport.Report report = (ValidityReport.Report)i.next();
				System.out.println(" - " + report);
			}
		}
		System.out.println("---------------qcě؂܂-------");
	}

	public static void printStatements(
		Model model,
		Resource res,
		Property prop,
		RDFNode object) {
		StmtIterator iter = res.listProperties(prop);

		while (iter.hasNext()) {
			Statement stm = iter.nextStatement();
			Resource sbj = stm.getSubject();
			Property prp = stm.getPredicate();
			RDFNode obj = stm.getObject();

			System.out.print(
				"- ["
					+ model.getNsURIPrefix(sbj.getNameSpace())
					+ ":"
					+ sbj.getLocalName()
					+ ", ");
			System.out.print(
				model.getNsURIPrefix(prp.getNameSpace()) + ":" + prp.getLocalName() + ", ");
			if (obj instanceof Resource)
				System.out.println(
					model.getNsURIPrefix(((Resource)obj).getNameSpace())
						+ ":"
						+ ((Resource)obj).getLocalName()
						+ "]");
			else
				System.out.println(obj + "]");

		}
	}
}
